import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.Hashtable;

import org.w3c.dom.Document;

import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.stream.*;
import javax.xml.transform.dom.*;
 
public class GedServlet extends HttpServlet {

    /**
    * Respond to an HTTP request
    */
   
    public void service(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
        res.setContentType("text/html");

        try {
            String clear = req.getParameter("clear");
            if (clear!=null && clear.equals("yes")) {
                resetData();
            }
            String family = req.getParameter("tree");
            //Document doc = getSourceDocument(family);
            //Source source = new DOMSource(doc);
            Source source = new StreamSource(
                new File(getServletContext().getRealPath("/" + family + ".xml")));

            Result result = new StreamResult(res.getOutputStream());   
         
            Templates style = getStyleSheet(); 
            Transformer transformer = style.newTransformer();
            transformer.setParameter("id", req.getParameter("id"));
            transformer.setParameter("tree", family);
            transformer.transform(source, result);
           
        } catch (Exception err) {
            PrintStream ps = new PrintStream(res.getOutputStream());
            ps.println("Error applying stylesheet: " + err.getMessage());     
        } 
    }

    /**
    * Get the prepared stylesheet from memory; prepare it if necessary
    */

    private synchronized Templates getStyleSheet() 
    throws TransformerConfigurationException, java.io.IOException {
        if (stylesheet == null) {
            File sheet = new File(getServletContext().getRealPath("/ged-servlet.xsl"));

            stylesheet = TransformerFactory.newInstance().
                            newTemplates(new StreamSource(sheet));  

        }
        return stylesheet;
    }

    /**
    * Load the source document
    */

    private synchronized Document getSourceDocument(String tree) 
    throws javax.xml.parsers.ParserConfigurationException,
           org.xml.sax.SAXException,
           java.io.IOException {
        Document doc = (Document)trees.get(tree);
        if (doc==null) {
            File source = new File(getServletContext().getRealPath("/" + tree + ".xml"));
            doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(source);
        }
        return doc;
    }

    /**
    * Reset data held in memory
    */

    private synchronized void resetData() {
        trees = new Hashtable();
        stylesheet = null;
    }

    private Hashtable trees = new Hashtable();
    private Templates stylesheet = null;
}
