<xsl:transform
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:saxon="http://icl.com/saxon"
 extension-element-prefixes="saxon"
 version="1.0"
>
<xsl:import href="person.xsl"/>

<xsl:param name="dir" select="'.'"/>

<xsl:template match="/">
	<xsl:for-each select="*/INDI">
		<xsl:document href="{$dir}/{@ID}.html">
			<xsl:apply-templates select="."/>
		</xsl:document>
	</xsl:for-each>
    <xsl:document href="{$dir}/index.html">
        <xsl:call-template name="make-index"/>
    </xsl:document>
</xsl:template>

<xsl:template name="make-index">
	<html>
    <head>
        <title>Index of names</title>
    </head>
    <body>
    <h1>Index of names</h1>
    <p>
    	<xsl:for-each select="/*/INDI/NAME">
    		<xsl:sort select="S"/>
    		<xsl:sort select="text()"/>
    	    <a>
    		    <xsl:attribute name="href">
    			    <xsl:call-template name="make-href"/>
    		    </xsl:attribute>
    		    <xsl:value-of select="S"/>, 
                <xsl:for-each select="text()">
                    <xsl:value-of select="concat(' ', ., ' ')"/>
                </xsl:for-each>
    	    </a>
    		<br/>
    	</xsl:for-each>
	</p>
    </body>
    </html>
</xsl:template>

</xsl:transform>


